Subject: Re: [nvo3] NVO3 WG Adoption of draft-quinn-vxlan-gpe-04

From: Behcet Sarikaya <[email-masked]>
Date: Fri, 1 May 2015 11:25:40 -0500

Hi Benson,

Thank you for your kind mail.
Please see inline.

Regards,

Behcet

On Thu, Apr 30, 2015 at 7:01 PM, Benson Schliesser
<[email-masked]> wrote:
> Hi, Behcet.
>
> Still writing as an individual:
>
> After reading your email (quoted below) several times, I suspect that you
> don't understand the way layering works.

I am willing to learn new things if I missed something. It is always
possible to apologize if I offended someone. I believe here there is
no offense, it is all technical.

> I'm not sure if this is just in the
> context of what NVO3 is doing or in the general case, but I think it is well
> understood by others that have been contributing here. It's up to them to
> decide how much they want to respond to your questions. But I personally
> don't have the time to provide you this education.
>

I am concerned that drafts are being accepted with few or almost no
technical discussions.
If there has been some discussions on the list where my concern has
been addressed, please provide me the link, I am going to check.

I printed the draft and read it again. One thing is they use next
protocol not protocol field as you said. Maybe they are trying to
justify why they need different protocol numbers than already assigned
by IANA.

> Now writing as co-chair:
>
> You can certainly ask people to help you understand and/or explain their
> drafts. I'm very tolerant of open discussion on the list as long as it is
> constructive toward the WG goals.
>
> NVO3 has adopted GUE and VXLAN-GPE, and is in process of adopting GENEVE
> pending an IPR statement from one of the authors. These are potentially
> implemented as overlay data plane encaps.
>
> As a WG chair I am guided by WG consensus. The consensus seems to favor
> these protocols as WG work items. I'm not yet aware of any specific issues
> that need to be addressed by the authors.
>

Let me say this, sorry Benson, no offense to you but in this list I
hardly see chair reviews, unlike most other WGs.

I noticed that the issue tracker has never been used in nvo3.
Once this draft is submitted as WG draft, I am going to be happy to
provide my technical comments on the issue tracker maybe lead the way.

> -Benson
>
>
>
> On Thursday, April 30, 2015, Behcet Sarikaya <[email-masked]> wrote:
>>
>> On Thu, Apr 30, 2015 at 6:50 AM, Benson Schliesser
>> <[email-masked]> wrote:
>> > Hi, Behcet. Just speaking as an individual: I understand the purpose of
>> > GPE
>> > as being the addition of a protocol field to VXLAN.
>>
>> This is where I have concerns.
>> Protocol field is defined for IP header. Ethernet also has a similar
>> field (called Ether Type).
>> In RFC 7348, it is clearly defined that the next protocol is UDP
>> (value 17) for VXLAN.
>> Protocol field values are defined in
>> http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml
>>
>> Yes, there is IPv4 (value 4) and IPv6 (value 41). Just like Ethernet
>> Ether Type has values, I think someone mentioned it.
>>
>> GPE draft is introducing another registry for the protocol field,.
>>
>> There must be some reason why they defined protocol field only for
>> IPv4/v6 not e.g. for UDP.
>>
>> VXLAN is UDP encapsulation, it is not a different protocol.
>>
>> It seems like Paul has different opinion on these, because I noticed
>> he added protocol field to his NSH draft also.
>>
>> Benson, is it OK to ask from Paul why?
>> Or you want to ban me from asking these types of technical questions?
>>
>>
>> > It is not specifically a
>> > IPv4/v6 attribute, but more general.
>>
>> Please see above.
>> > If you don't understand the general
>> > case of how or why v4 and v6 are multiplexed with the lower-layer
>> > protocol
>> > field then I don't think that's specifically germane to the nvo3 mailing
>> > list.
>>
>> I made my point above, please see above.
>> >
>> > As for comparing GUE and VXLAN-GPE, that seems like a fair discussion to
>> > have. But I don't currently see any especially constructive way to do
>> > that.
>> >
>>
>> Can you please then explain it? How are these two compared?
>> I am saying they are different things. GUE is currently being
>> discussed in Intarea list.
>>
>> Regards,
>>
>> Behcet
>> > Cheers,
>> > -Benson
>> >
>> >
>> > On Wednesday, April 29, 2015, Behcet Sarikaya <[email-masked]>
>> > wrote:
>> >>
>> >>  Is gpe talking about encapsulation of inner packets, i.e. data plane?
>> >> If yes then it is like GUE. Then one would ask why do we need another
>> >> GUE?
>> >>
>> >> Looking at the abstract which says
>> >>
>> >> changes to the VXLAN header
>> >>
>> >> I think the answer is no.
>> >>
>> >> I would understand a few flags like OAM that you defined as extensions
>> >> to
>> >> VXLAN.
>> >>
>> >> But I have trouble understanding next protocol field.
>> >> I think VXLAN encapsulation does not need next protocol field because
>> >> what is being encapsulated is completely defined in RFC7348.
>> >>
>> >> If in the future the need arises that something like NSH also needs to
>> >> be defined then the best way to do is to.define RFC7348bis and add it
>> >> there.
>> >>
>> >> Regards,
>> >>
>> >> Behcet
>> >>
>> >>
>> >> On Wed, Apr 29, 2015 at 2:09 PM, Larry Kreeger (kreeger)
>> >> <[email-masked]> wrote:
>> >> > Regarding Joe Touch's comment about explicitly NOT indicating IPv4 vs
>> >> > IPv6
>> >> > in the Next Protocol (only indicating IP), I don't see what the
>> >> > advantages
>> >> > of doing this are.  It seems more philosophical.
>> >> >
>> >> > By indicating IPv4/IPv6 in the next protocol, it allows
>> >> > implementations
>> >> > to
>> >> > only make one decision before parsing the IP header.  By doing two
>> >> > steps
>> >> > NP->IP->IPv4/v6, it adds one more parsing step to the implementation,
>> >> > for
>> >> > no gain that I can think of.
>> >> >
>> >> > As Diego pointed out earlier, there is already a precedent in
>> >> > Ethernet
>> >> > for
>> >> > indicating the IP version in the next protocol from the layer below
>> >> > it.
>> >> >
>> >> >  - Larry
>> >> >
>> >> > On 4/29/15 11:36 AM, "Behcet Sarikaya" <[email-masked]>
>> >> > wrote:
>> >> >
>> >> >>On Wed, Apr 29, 2015 at 1:13 PM, Paul Quinn (paulq) <[email-masked]>
>> >> >>wrote:
>> >> >>>
>> >> >>>> On Apr 29, 2015, at 12:01 PM, Behcet Sarikaya
>> >> >>>> <[email-masked]>
>> >> >>>>wrote:
>> >> >>>>
>> >> >>>> On Tue, Apr 28, 2015 at 5:03 PM, Behcet Sarikaya
>> >> >>>><[email-masked]> wrote:
>> >> >>>>> Hi Benson,
>> >> >>>>>
>> >> >>>>> Joe Touch wrote this on intarea list:
>> >> >>>>>
>> >> >>>>> There is no reason for having the GUE header differentiate
>> >> >>>>> between
>> >> >>>>> payload=IPv4 and payload=IPv6. The IP version is addressed by the
>> >> >>>>> version field of the IP header. If GUE encapsulates both type of
>> >> >>>>> IP
>> >> >>>>>the
>> >> >>>>> same way (and it should), it should NOT differentiate between
>> >> >>>>> them
>> >> >>>>> in
>> >> >>>>> its (GUE) header.
>> >> >>>>>
>> >> >>>>>
>> >> >>>>> I think the same applies to gpe header.
>> >> >>>>>
>> >> >>>>> Plus the issues on the "NSH" protocol.
>> >> >>>>
>> >> >>>> Curiously if you look at the nsh draft, Section 3.2,
>> >> >>>>
>> >> >>>> NSH Base Header
>> >> >>>>
>> >> >>>> also has a next protocol field with the same encoding.
>> >> >>>>
>> >> >>>> Anybody understands what is going on?
>> >> >>>
>> >> >>> Yes, the concept is that you don't know what you want to carry via
>> >> >>> GPE.
>> >> >>> Today it might be v4, v6, ethernet, NSH or something else.
>> >> >>> Tomorrow,
>> >> >>>who knows?  But more importantly, we need to enable that stacking to
>> >> >>>occur.
>> >> >>>
>> >> >>
>> >> >>
>> >> >>Please convince not me but Joe Touch on v4 and v6 thing.
>> >> >>
>> >> >>> The format of NSH is orthogonal -- as is the format of Ethernet for
>> >> >>>that matter.  From an outer header (i.e. VXLAN-GPE or other) you
>> >> >>> need
>> >> >>> to
>> >> >>>be able to identify the inner protocol.
>> >> >>>
>> >> >>
>> >> >>Are we talking about VM-to-VM communication? I think that is what
>> >> >>VXLAN was designed for.
>> >> >>
>> >> >>Regards,
>> >> >>
>> >> >>Behcet
>> >> >>> Paul
>> >> >>>
>> >> >